//=========================================================================
//Copyright LizardOfOz.
//=========================================================================

MODEL_PICKUP <- "models/items/crystal_ball_pickup_major.mdl";
PrecacheModel(MODEL_PICKUP);
::token_pickups <- {};
PrecacheScriptSound("Halloween.spell_pickup");

::token_drop_chance_ally <- 5;
::token_drop_chance_enemy <- 3;
::token_drop_chance_empty <- 2;

OnGameEvent("player_death", 0, function(player, params)
{
    if (vipBoostTokens <= 1)
    {
        if (RandomInt(1, token_drop_chance_empty) != 1)
            return;
    }
    else if (player.GetTeam() != TF_TEAM_VIP)
    {
        if (RandomInt(1, token_drop_chance_enemy) != 1)
            return;
    }
    else if (RandomInt(1, token_drop_chance_ally) != 1)
        return;

    if (IsVIP(player))
        return;

    local vip = GetVIPPlayer();
    if (!IsValidPlayer(vip))
        return;

    local proxy_entity = Entities.CreateByClassname("obj_sentrygun");
    SetPropBool(proxy_entity, "m_bForcePurgeFixedupStrings", true);
    proxy_entity.SetAbsOrigin(player.GetOrigin());
    proxy_entity.SetAbsAngles(QAngle());
    proxy_entity.DispatchSpawn();
    proxy_entity.SetModel(MODEL_PICKUP);
    proxy_entity.AddEFlags(Constants.FEntityEFlags.EFL_NO_THINK_FUNCTION)
    proxy_entity.SetSolid(Constants.ESolidType.SOLID_NONE);
    SetPropBool(proxy_entity, "m_bPlacing", true);
    SetPropInt(proxy_entity, "m_fObjectFlags", 2);
    SetPropEntity(proxy_entity, "m_hBuilder", vip);
    EntFireByHandle(proxy_entity, "Kill", "", 20, null, null);

    token_pickups[proxy_entity] <- 1;
});

AddTimer(0.1, -1, function()
{
    local vip = GetVIPPlayer();
    if (!IsValidPlayer(vip))
        return;

    local vipOrigin = vip.GetOrigin();
    foreach(tokenEnt,_ in token_pickups)
    {
        if (!tokenEnt || !tokenEnt.IsValid())
        {
            delete token_pickups[tokenEnt];
            return;
        }
        if ((vipOrigin - tokenEnt.GetOrigin()).Length() < 64)
        {
            delete token_pickups[tokenEnt];
            tokenEnt.Kill();
            vipBoostTokens++;
            EmitSoundOnClient("Halloween.spell_pickup", vip);
            return;
        }
    }
});