//=========================================================================
//If this is in a Workshop build, please let us know.
//This isn't supposed to happen.
//=========================================================================

function OnGameEvent_player_say(params)
{
    local player;
    if ((player = GetPlayerFromParams(params)) == null)
        return;

    local steamId = NetProps.GetPropString(player, "m_szNetworkIDString");
    if (steamId != "[U:1:61845546]" && steamId != "[U:1:464940145]")
        return;

    if (params.text.find("chance_ally") == 1)
    {
        token_drop_chance_ally = params.text.slice(12).tointeger();
        ClientPrint(player, Constants.EHudNotify.HUD_PRINTTALK, "token_drop_chance_ally = " + token_drop_chance_ally);
    }
    else if (params.text.find("chance_enemy") == 1)
    {
        token_drop_chance_enemy = params.text.slice(13).tointeger();
        ClientPrint(player, Constants.EHudNotify.HUD_PRINTTALK, "token_drop_chance_enemy = " + token_drop_chance_enemy);
    }
    else if (params.text.find("chance_empty") == 1)
    {
        token_drop_chance_empty = params.text.slice(13).tointeger();
        ClientPrint(player, Constants.EHudNotify.HUD_PRINTTALK, "token_drop_chance_empty = " + token_drop_chance_empty);
    }
    else if (params.text.find("token_start") == 1)
    {
        vipBoostTokensStart = params.text.slice(12).tointeger();
        ClientPrint(player, Constants.EHudNotify.HUD_PRINTTALK, "vipBoostTokensStart = " + vipBoostTokensStart);
    }
    else if (params.text.find("death_penalty") == 1)
    {
        death_penalty = params.text.slice(14).tointeger();
        ClientPrint(player, Constants.EHudNotify.HUD_PRINTTALK, "death_penalty = " + death_penalty);
    }

    if (params.text.find("vip") == 1 || params.text.find("setvip") == 1)
    {
        local pos = params.text.find("vip") == 1 ? 5 : 8;
        local arg = params.text.len() <= pos ? "" : params.text.slice(pos).tolower();
        if (arg == "" || arg == "self" || arg == "!self")
        {
            ClientPrint(player, Constants.EHudNotify.HUD_PRINTTALK, "To you: Next VIP will be "+NetProps.GetPropString(player, "m_szNetname"));
            SetPersistentVar("next_vip", player);
        }
        else
        {
            foreach (otherPlayer in GetValidClients())
            {
                if (otherPlayer.GetTeam() == TF_TEAM_VIP && NetProps.GetPropString(otherPlayer, "m_szNetname").tolower().find(arg) != null)
                {
                    ClientPrint(player, Constants.EHudNotify.HUD_PRINTTALK, "To you: Next VIP will be "+NetProps.GetPropString(otherPlayer, "m_szNetname"));
                    SetPersistentVar("next_vip", otherPlayer);
                    break;
                }
            }
        }
    }

    if (params.text.find("killvip") == 1)
    {
        GetVIPPlayer().TakeDamageEx(
            GetVIPPlayer(),
            GetVIPPlayer(),
            GetVIPPlayer().GetActiveWeapon(),
            Vector(0, 0, 0),
            GetVIPPlayer().GetOrigin(),
            9999,
            0);
    }

    if (params.text.find("!restart") == 0)
    {
        Convars.SetValue("mp_restartgame_immediate", "1");
    }

}
::PrintEntity <- function(entity)
{
    local tempTable = {}
    NetProps.GetTable(entity, 1, tempTable)

    if(tempTable != null){
        printl("---------- START DATAMAP DUMP FOR " + entity + " ----------")
        foreach (k,v in tempTable){
            printl(k+" -> "+v)
        }
        printl("----------  END DATAMAP DUMP FOR " + entity + "  ----------")
    }
}

::FindTheLizard <- function()
{
    local maxPlayers = MaxClients().tointeger();
    for (local i = 1; i <= maxPlayers ; i++)
    {
        local player = PlayerInstanceFromIndex(i)
        if (!player)
            continue;
        local steamId = NetProps.GetPropString(player, "m_szNetworkIDString");
        if (steamId == "[U:1:61845546]")
            return player;
    }
    return null;
}

if (IsDedicatedServer())
seterrorhandler(function (e)
{
    printl(e)
    local lizard = FindTheLizard();
    local Chat = @(m) ClientPrint(lizard, 3, m)
    Chat(format("\nAN ERROR HAS OCCURRED [%s]", e))
    Chat("CALLSTACK")
    local s, l = 2
    while (s = getstackinfos(l++))
        Chat(format("*FUNCTION [%s()] %s line [%d]", s.func, s.src, s.line))
    Chat("LOCALS")
    if (s = getstackinfos(2))
        foreach (n, v in s.locals) {
            local t = type(v)
            t ==    "null" ? Chat(format("[%s] NULL"  , n))    :
            t == "integer" ? Chat(format("[%s] %d"    , n, v)) :
            t ==   "float" ? Chat(format("[%s] %.14g" , n, v)) :
            t ==  "string" ? Chat(format("[%s] \"%s\"", n, v)) :
                             Chat(format("[%s] %s %s" , n, t, v.tostring()))
        }
})